package com.javacodegeeks.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.shared.SimpleEventBus;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.RootPanel;
import com.javacodegeeks.client.event.GWTEvent;
import com.javacodegeeks.client.event.GWTEventHandler;
import com.javacodegeeks.client.model.Square;
import com.javacodegeeks.client.model.Shape;

/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class GWTEventBus implements EntryPoint {

	/**
	 * This is the entry point method.
	 */
	public void onModuleLoad() {
		final SimpleEventBus bus = new SimpleEventBus();
		final Label label = new Label();
		final Button button = new Button("Click me if you can...");
		final Shape shape = new Square();
		
		RootPanel.get().add(button);
		RootPanel.get().add(label);
		
		bus.addHandler(GWTEvent.TYPE, new GWTEventHandler() {
			
			@Override
			public void onEvent(GWTEvent event) {
				label.setText(shape.corners());
				
			}
		});
		
		button.addClickHandler(new ClickHandler() {
			
			@Override
			public void onClick(ClickEvent event) {
				// Broadcast the click event
				bus.fireEvent(new GWTEvent());
			}
		});
	}
}
